<h1 align="center">
	<img width="500" src="https://github.com/mindsdb/mindsdb-docs/blob/master/mindsdb-docs/docs/assets/MindsDBjaison@3x.png" alt="jaison">
	<br>
	<br>
</h1>

![jaison Actions workflow](https://github.com/mindsdb/jaison/workflows/jaison%20Actions%20workflow/badge.svg)
![](https://img.shields.io/badge/python-3.6%20|%203.7|%203.8-brightgreen.svg)
[![PyPI version](https://badge.fury.io/py/jaison.svg)](https://badge.fury.io/py/jaison)
![PyPI - Downloads](https://img.shields.io/pypi/dm/jaison)
[![Discourse posts](https://img.shields.io/discourse/posts?server=https%3A%2F%2Fcommunity.mindsdb.com%2F)](https://community.mindsdb.com/)

jaison is like Legos for Machine Learning. 

A Pytorch based framework that breaks down machine learning problems into smaller blocks that can be glued together seamlessly with one objective:

- Make it so simple that you can build predictive models with as little as one line of code.


# Documentation
Learn more from the [jaison's docs](https://docs.mindsdb.com/jaison/info/).  

## Try it out

### Installation
You can install jaison from pip:

```python
pip3 install jaison
```
>Note: depending on your environment, you might have to use pip instead of pip3 in the above command.

### Usage
Given the simple sensor_data.csv let's predict sensor3 values.
| sensor1  | sensor2 | sensor3 |
|----|----|----|
|  1 | -1 | -1 |
| 0  | 1  | 0  |
| -1  |- 1  |1  |

Import [Predictor](https://mindsdb.github.io/jaison/API/) from jaison
```python
from jaison import Predictor
```

Train the model.
```python
import pandas
sensor3_predictor = Predictor(output=['sensor3']).learn(from_data=pandas.read_csv('sensor_data.csv'))
```
You can now predict what *sensor3* value will be.

```python
prediction = sensor3_predictor.predict(when={'sensor1':1, 'sensor2':-1})
```

* You can also try jaison in Google Colab: [![Google Colab](https://colab.research.google.com/assets/colab-badge.svg "jaison")](https://colab.research.google.com/drive/10W43sur_uj28ROiGuAIF9X46_Xrx1e7K)

## Contributing

Thanks for your interest. There are many ways to contribute to this project. Please, check out our [Contribution guide](https://github.com/mindsdb/jaison/blob/master/CONTRIBUTING.md).

### Current contributors 

<a href="https://github.com/mindsdb/jaison/graphs/contributors">
  <img src="https://contributors-img.web.app/image?repo=mindsdb/jaison" />
</a>

Made with [contributors-img](https://contributors-img.web.app).

## License ![PyPI - License](https://img.shields.io/pypi/l/jaison)

* [jaison License](https://github.com/mindsdb/jaison/blob/master/LICENSE)
